Package org.apache.sling.discovery.oak

## Annotation Type DiscoveryServiceCentralConfig

    public @interface DiscoveryServiceCentralConfig

### Field Summary

Fields
`static int` `DEFAULT_BACKOFF_STABLE_FACTOR`
`static int` `DEFAULT_BACKOFF_STANDBY_FACTOR`
`static long` `DEFAULT_CLUSTER_SYNC_SERVICE_INTERVAL`
`static long` `DEFAULT_CLUSTER_SYNC_SERVICE_TIMEOUT`
`static long` `DEFAULT_DISCOVERY_LITE_CHECK_INTERVAL`
`static String` `DEFAULT_DISCOVERY_RESOURCE_PATH`
`static boolean` `DEFAULT_INVERT_LEADER_ELECTION_PREFIX_ORDER`
`static long` `DEFAULT_JOINER_DELAY_SECONDS`
`static long` `DEFAULT_LEADER_ELECTION_PREFIX`
`static int` `DEFAULT_MIN_EVENT_DELAY`
`static long` `DEFAULT_SHARED_KEY_INTERVAL` The default lifetime of a HMAC shared key in ms.
`static int` `DEFAULT_SO_TIMEOUT`
`static int` `DEFAULT_SOCKET_CONNECT_TIMEOUT`
`static boolean` `DEFAULT_SUPPRESS_PARTIALLY_STARTED_INSTANCES`
`static long` `DEFAULT_SUPPRESSION_TIMEOUT_SECONDS`
`static long` `DEFAULT_TOPOLOGY_CONNECTOR_INTERVAL`
`static long` `DEFAULT_TOPOLOGY_CONNECTOR_TIMEOUT`
`static String[]` `DEFAULT_TOPOLOGY_CONNECTOR_WHITELIST`
`static String` `JOINER_DELAY_ENABLED_SYSTEM_PROPERTY_NAME`

### Optional Element Summary

Optional Elements
`boolean` `autoStopLocalLoopEnabled` If set to true, local-loops of topology connectors are automatically stopped when detected so.
`int` `backoffStableFactor` The property for defining the maximum backoff factor for stable connectors
`int` `backoffStandbyFactor` The property for defining the backoff factor for standby (loop) connectors
`long` `clusterSyncServiceInterval`
`long` `clusterSyncServiceTimeout`
`long` `connectorPingInterval` Configure the interval (in seconds) according to which the heartbeats are exchanged in the topology.
`long` `connectorPingTimeout` Configure the timeout (in seconds) after which an instance is considered dead/crashed.
`long` `discoveryLiteCheckInterval`
`String` `discoveryResourcePath` Path of resource where to keep discovery information, e.g /var/discovery/oak/
`boolean` `enableEncryption` If set to true, and the whitelist is disabled, messages will be encrypted.
`boolean` `enableSyncToken` If set to true a syncToken will be used on top of waiting for deactivating instances to be fully processed.
`boolean` `gzipConnectorRequestsEnabled` If set to true, request body will be gzipped - only works if counter-part accepts gzip-requests!
`boolean` `hmacEnabled` If set to true, hmac is enabled and the white list is disabled.
`long` `hmacSharedKeyTTL`
`boolean` `invertLeaderElectionPrefixOrder`
`long` `joinerDelaySeconds`
`long` `leaderElectionPrefix`
`int` `minEventDelay` Configure the time (in seconds) which must be passed at minimum between sending TOPOLOGY_CHANGING/_CHANGED (avoid flooding).
`String` `sharedKey` The value fo the shared key, shared amongst all instances in the same cluster.
`int` `socketConnectTimeout` Configure the socket connect timeout for topology connectors.
`int` `soTimeout` Configure the socket read timeout (SO_TIMEOUT) for topology connectors.
`long` `suppressionTimeoutSeconds`
`boolean` `suppressPartiallyStartedInstance`
`String[]` `topologyConnectorUrls` URLs where to join a topology, eg http://localhost:4502/libs/sling/topology/connector
`String[]` `topologyConnectorWhitelist` list of ips and/or hostnames which are allowed to connect to /libs/sling/topology/connector

### Field Detail

#### DEFAULT_TOPOLOGY_CONNECTOR_TIMEOUT

    static final long DEFAULT_TOPOLOGY_CONNECTOR_TIMEOUT

#### DEFAULT_TOPOLOGY_CONNECTOR_INTERVAL

    static final long DEFAULT_TOPOLOGY_CONNECTOR_INTERVAL

#### DEFAULT_DISCOVERY_LITE_CHECK_INTERVAL

    static final long DEFAULT_DISCOVERY_LITE_CHECK_INTERVAL

#### DEFAULT_CLUSTER_SYNC_SERVICE_TIMEOUT

    static final long DEFAULT_CLUSTER_SYNC_SERVICE_TIMEOUT

#### DEFAULT_CLUSTER_SYNC_SERVICE_INTERVAL

    static final long DEFAULT_CLUSTER_SYNC_SERVICE_INTERVAL

#### DEFAULT_MIN_EVENT_DELAY

    static final int DEFAULT_MIN_EVENT_DELAY

#### DEFAULT_SOCKET_CONNECT_TIMEOUT

    static final int DEFAULT_SOCKET_CONNECT_TIMEOUT

#### DEFAULT_SO_TIMEOUT

    static final int DEFAULT_SO_TIMEOUT

#### DEFAULT_BACKOFF_STANDBY_FACTOR

    static final int DEFAULT_BACKOFF_STANDBY_FACTOR

#### DEFAULT_BACKOFF_STABLE_FACTOR

    static final int DEFAULT_BACKOFF_STABLE_FACTOR

#### DEFAULT_LEADER_ELECTION_PREFIX

    static final long DEFAULT_LEADER_ELECTION_PREFIX

#### DEFAULT_TOPOLOGY_CONNECTOR_WHITELIST

    static final String[] DEFAULT_TOPOLOGY_CONNECTOR_WHITELIST

#### DEFAULT_DISCOVERY_RESOURCE_PATH

    static final String DEFAULT_DISCOVERY_RESOURCE_PATH

#### DEFAULT_INVERT_LEADER_ELECTION_PREFIX_ORDER

    static final boolean DEFAULT_INVERT_LEADER_ELECTION_PREFIX_ORDER

#### DEFAULT_SUPPRESS_PARTIALLY_STARTED_INSTANCES

    static final boolean DEFAULT_SUPPRESS_PARTIALLY_STARTED_INSTANCES

#### JOINER_DELAY_ENABLED_SYSTEM_PROPERTY_NAME

    static final String JOINER_DELAY_ENABLED_SYSTEM_PROPERTY_NAME

#### DEFAULT_SUPPRESSION_TIMEOUT_SECONDS

    static final long DEFAULT_SUPPRESSION_TIMEOUT_SECONDS

#### DEFAULT_JOINER_DELAY_SECONDS

    static final long DEFAULT_JOINER_DELAY_SECONDS

#### DEFAULT_SHARED_KEY_INTERVAL

    static final long DEFAULT_SHARED_KEY_INTERVAL

The default lifetime of a HMAC shared key in ms. (4h)

### Element Detail

#### connectorPingTimeout

    long connectorPingTimeout

Configure the timeout (in seconds) after which an instance is considered dead/crashed.

Default:
  120L

#### connectorPingInterval

    long connectorPingInterval

Configure the interval (in seconds) according to which the heartbeats are exchanged in the topology.

Default:
  30L

#### discoveryLiteCheckInterval

    long discoveryLiteCheckInterval

Default:
  2L

#### clusterSyncServiceTimeout

    long clusterSyncServiceTimeout

Default:
  120L

#### clusterSyncServiceInterval

    long clusterSyncServiceInterval

Default:
  2L

#### enableSyncToken

    boolean enableSyncToken

If set to true a syncToken will be used on top of waiting for deactivating instances to be fully processed. If set to false, only deactivating instances will be waited for to be fully processed.

Default:
  true

#### minEventDelay

    int minEventDelay

Configure the time (in seconds) which must be passed at minimum between sending TOPOLOGY_CHANGING/_CHANGED (avoid flooding).

Default:
  3

#### socketConnectTimeout

    int socketConnectTimeout

Configure the socket connect timeout for topology connectors.

Default:
  10

#### soTimeout

    int soTimeout

Configure the socket read timeout (SO_TIMEOUT) for topology connectors.

Default:
  10

#### topologyConnectorUrls

    String[] topologyConnectorUrls

URLs where to join a topology, eg http://localhost:4502/libs/sling/topology/connector

Default:
  {}

#### topologyConnectorWhitelist

    String[] topologyConnectorWhitelist

list of ips and/or hostnames which are allowed to connect to /libs/sling/topology/connector

Default:
  {"localhost", "127.0.0.1"}

#### discoveryResourcePath

    String discoveryResourcePath

Path of resource where to keep discovery information, e.g /var/discovery/oak/

Default:
  "/var/discovery/oak/"

#### autoStopLocalLoopEnabled

    boolean autoStopLocalLoopEnabled

If set to true, local-loops of topology connectors are automatically stopped when detected so.

Default:
  false

#### gzipConnectorRequestsEnabled

    boolean gzipConnectorRequestsEnabled

If set to true, request body will be gzipped - only works if counter-part accepts gzip-requests!

Default:
  false

#### hmacEnabled

    boolean hmacEnabled

If set to true, hmac is enabled and the white list is disabled.

Default:
  false

#### enableEncryption

    boolean enableEncryption

If set to true, and the whitelist is disabled, messages will be encrypted.

Default:
  false

#### sharedKey

    String sharedKey

The value fo the shared key, shared amongst all instances in the same cluster.

Default:
  ""

#### hmacSharedKeyTTL

    long hmacSharedKeyTTL

Default:
  14400000L

#### backoffStandbyFactor

    int backoffStandbyFactor

The property for defining the backoff factor for standby (loop) connectors

Default:
  5

#### backoffStableFactor

    int backoffStableFactor

The property for defining the maximum backoff factor for stable connectors

Default:
  5

#### leaderElectionPrefix

    long leaderElectionPrefix

Default:
  1L

#### invertLeaderElectionPrefixOrder

    boolean invertLeaderElectionPrefixOrder

Default:
  false

#### suppressPartiallyStartedInstance

    boolean suppressPartiallyStartedInstance

Default:
  false

#### suppressionTimeoutSeconds

    long suppressionTimeoutSeconds

Default:
  -1L

#### joinerDelaySeconds

    long joinerDelaySeconds

Default:
  0L